; 

    include \masm32\include\masm32rt.inc
    include \masm32\include\pdh.inc
    includelib  \masm32\lib\pdh.lib
    
    WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
    WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

; 

    PDH_MAX_COUNTER_PATH    equ 2048
    PDH_FMT_LONG            equ 000000100h
    PDH_CSTATUS_VALID_DATA  equ 0

    IDI_TASKBARICON         equ 0
    WM_CALLBACK             equ WM_USER + 100
    IDM_EXIT                equ 1000
    ID_TIMER                equ 1

    PDH_COUNTER_PATH_ELEMENTS STRUCT
      szMachineName       DWORD ?
      szObjectName        DWORD ?
      szInstanceName      DWORD ?
      szParentInstance    DWORD ?
      dwInstanceIndex     DWORD ?
      szCounterName       DWORD ?
    PDH_COUNTER_PATH_ELEMENTS ENDS

    PDH_FMT_COUNTERVALUE STRUCT
      CStatus             DWORD ?
      padding             DWORD ?
      UNION
        longValue         DWORD ?
        doubleValue       REAL8 ?
        largeValue        QWORD ?
        AnsiStringValue   DWORD ?
        WideStringValue   DWORD ?
      ENDS
    PDH_FMT_COUNTERVALUE ENDS

    PDH_CVERSION_WIN40 equ 00000400h
    PDH_CVERSION_WIN50 equ 00000500h
    ; v1.1 revision of PDH -- basic log functions
    ; v1.2 of the PDH -- adds variable instance counters
    ; v1.3 of the PDH -- adds log service control & stubs for NT5/PDH v2 fn's
    ; v2.0 of the PDH -- is the NT v 5.0 B2 version
    PDH_VERSION equ PDH_CVERSION_WIN50 + 3
    
    PDH_CSTATUS_NO_MACHINE        equ 0800007D0h
      ; A computer entry could not be created
    PDH_CSTATUS_NO_OBJECT         equ 0C0000BB8h
      ; The specified object could not be found
    PDH_CSTATUS_NO_COUNTER        equ 0C0000BB9h
      ; The specified counter was not found
    PDH_MEMORY_ALLOCATION_FAILURE equ 0C0000BBBh
      ;  A memory buffer could not be allocated
    PDH_INVALID_HANDLE            equ 0C0000BBCh
      ; The query handle is not valid
    PDH_INVALID_ARGUMENT          equ 0C0000BBDh
      ; One or more arguments are invalid
    PDH_FUNCTION_NOT_FOUND        equ 0C0000BBEh
      ; The calculation function for this counter could not be determined
    PDH_CSTATUS_NO_COUNTERNAME    equ 0C0000BBFh
      ; An empty counter name path string was passed in
    PDH_CSTATUS_BAD_COUNTERNAME   equ 0C0000BC0h
      ; The counter name path string could not be parsed or interpreted

; 

    .data?

      commandLine   dd ?

      hInstance     dd ?
      hWnd          dd ?
      hPopupMenu    dd ?

      hIconAct      dd ?
      hIconNoAct    dd ?

      nSize         dd ?
      hQuery        dd ?
      hCounter      dd ?
      prevValue     dd ?

      pcpe          PDH_COUNTER_PATH_ELEMENTS <>
      pfc           PDH_FMT_COUNTERVALUE <>

      nid           NOTIFYICONDATA <>

    .data

      className     db "HddActivityClass",0
      windowName    db " HDD Activity ",0
       
      machineName   db MAX_COMPUTERNAME_LENGTH + 1 dup(0)
      objectName    db "PhysicalDisk",0
      counterName   db "% Disk Time",0
      instanceName  db "_Total",0
      counterPath   db PDH_MAX_COUNTER_PATH dup(0)

; 

    .code

start:

    invoke GetModuleHandle, NULL
    mov   hInstance, eax

    invoke GetCommandLine
    mov   commandLine, eax

    invoke WinMain, hInstance, NULL, commandLine, SW_SHOWDEFAULT
    invoke ExitProcess, eax

; 

WinMain proc hInst:DWORD,hPrevInst:DWORD,cmdLine:DWORD,cmdShow:DWORD

    LOCAL wc  :WNDCLASSEX
    LOCAL msg :MSG

    LOCAL dwVersion:DWORD

    invoke PdhGetDllVersion, ADDR dwVersion
    MsgBox 0, uhex$(dwVersion),"pdh.dll version",0

    mov   nSize, SIZEOF machineName
    invoke GetComputerName, ADDR machineName, ADDR nSize
    mov   pcpe.szMachineName, OFFSET machineName
    mov   pcpe.szObjectName, OFFSET objectName
    mov   pcpe.szCounterName, OFFSET counterName
    mov   pcpe.szCounterName, OFFSET counterName
    mov   pcpe.szInstanceName, OFFSET instanceName
    mov   pcpe.szParentInstance, NULL
    mov   pcpe.dwInstanceIndex, -1

    mov   nSize, SIZEOF counterPath
    invoke PdhMakeCounterPath, ADDR pcpe, ADDR counterPath, ADDR nSize, 0
    .IF eax != ERROR_SUCCESS
      MsgBox 0,"PdhMakeCounterPath failed",NULL,0
      jmp   fail
    .ELSE
      MsgBox 0,ADDR counterPath,"Counter Path",0
    .ENDIF

    invoke PdhOpenQuery, NULL, NULL, ADDR hQuery
    .IF eax != ERROR_SUCCESS
      MsgBox 0,"PdhOpenQuery failed", NULL,0
      jmp   fail
    .ENDIF

    invoke PdhAddCounter, hQuery, ADDR counterPath, NULL, ADDR hCounter
    .IF eax != ERROR_SUCCESS
      .IF eax < 16000
        MsgBox 0,LastError$(),"PdhAddCounter returned system error code",0
      .ELSE
        MsgBox 0, uhex$(eax),"PdhAddCounter returned PDH error code",0
      .ENDIF
      jmp   fail
    .ENDIF

    mov   wc.cbSize,        sizeof WNDCLASSEX
    mov   wc.style,         CS_HREDRAW or CS_VREDRAW \
                              or CS_BYTEALIGNWINDOW
    mov   wc.lpfnWndProc,   OFFSET WndProc
    mov   wc.cbClsExtra,    NULL
    mov   wc.cbWndExtra,    NULL
    m2m   wc.hInstance,     hInst
    mov   wc.hbrBackground, COLOR_WINDOW+1
    mov   wc.lpszMenuName,  NULL
    mov   wc.lpszClassName, OFFSET className
    mov   wc.hIcon,         NULL
    mov   wc.hCursor,       NULL
    mov   wc.hIconSm,       0
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            ADDR className,
                            ADDR windowName,
                            WS_OVERLAPPEDWINDOW,
                            0,0,240,160,
                            NULL, NULL,
                            hInst, NULL
    mov   hWnd, eax

    invoke SetTimer, hWnd, ID_TIMER, 100, NULL

    ;invoke ShowWindow, hWnd, SW_SHOWNORMAL   ; debug only
    ;invoke UpdateWindow, hWnd                ; debug only

  msgLoop:

    invoke GetMessage, ADDR msg, NULL, 0, 0
    .IF eax != 0
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage, ADDR msg
      jmp   msgLoop
    .ENDIF

    invoke PdhCloseQuery, hQuery
    invoke KillTimer, hWnd, ID_TIMER

    return msg.wParam

  fail:

    return 0

WinMain endp

; 

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL pt:POINT

    .IF uMsg == WM_CREATE

      mov   hIconAct, rv(LoadImage,hInstance,1000,IMAGE_ICON,0,0,NULL)
      mov   hIconNoAct, rv(LoadImage,hInstance,2000,IMAGE_ICON,0,0,NULL)

      mov   hPopupMenu, rv(CreatePopupMenu)
      invoke AppendMenu, hPopupMenu, MF_STRING, IDM_EXIT, chr$("Exit")

      mov   nid.cbSize, SIZEOF NOTIFYICONDATA
      m2m   nid.hwnd, hWin
      mov   nid.uID, IDI_TASKBARICON
      mov   nid.uFlags, NIF_ICON+NIF_MESSAGE+NIF_TIP
      mov   nid.uCallbackMessage, WM_CALLBACK
      m2m   nid.hIcon, hIconNoAct
      invoke lstrcpy, ADDR nid.szTip, ADDR windowName

      invoke Shell_NotifyIcon, NIM_ADD, ADDR nid

    .ELSEIF uMsg == WM_DESTROY

      invoke PostQuitMessage, NULL
      return 0

    .ELSEIF uMsg == WM_TIMER

      call TimerProc

    .ELSEIF uMsg == WM_COMMAND

      .IF lParam == 0

        invoke Shell_NotifyIcon, NIM_DELETE, ADDR nid

        mov eax, wParam
        .IF ax == IDM_EXIT
          invoke DestroyWindow, hWin
        .ENDIF

      .ENDIF

    .ELSEIF uMsg == WM_CALLBACK

      .IF wParam == IDI_TASKBARICON
        .IF lParam == WM_RBUTTONDOWN

          ; -------------------------------------------------------
          ; This code temporarily sets the foreground window to
          ; the current window to correct a problem with the menu
          ; not disappearing when the user clicks outside the menu.
          ; Tested under Windows 2000 only. See the PSDK or MSDN
          ; documentation for TrackPopupMenu.
          ; -------------------------------------------------------

          invoke GetForegroundWindow
          push  eax
          invoke SetForegroundWindow, hWin

          invoke GetCursorPos, ADDR pt
          invoke TrackPopupMenu, hPopupMenu, TPM_RIGHTALIGN,
            pt.x, pt.y, NULL, hWin, NULL

          pop   eax
          invoke SetForegroundWindow, eax

        .ENDIF
      .ENDIF

    .ENDIF

    invoke DefWindowProc, hWin, uMsg, wParam, lParam
    ret

WndProc endp

; 

TimerProc proc

    invoke PdhCollectQueryData, hQuery
    invoke PdhGetFormattedCounterValue,hCounter,PDH_FMT_LONG,0,ADDR pfc

    .IF pfc.CStatus == PDH_CSTATUS_VALID_DATA

        mov   eax, pfc.longValue

        .IF eax != prevValue

            mov prevValue, eax
            .IF eax
                m2m   nid.hIcon, hIconAct
            .ELSE
                m2m   nid.hIcon, hIconNoAct
            .ENDIF

            invoke Shell_NotifyIcon, NIM_MODIFY, ADDR nid

        .ENDIF

    .ENDIF

    ret

TimerProc endp

; 

end start

